#NoTrayIcon
#include 'windows.h.au3'

Global $hWindowProc = DllCallbackRegister('WindowProc', 'long', 'hwnd;uint;wparam;lparam')
Global $stAppName = DllStructCreate('char szAppName[128];char szClassName[100]')
Global $szAppName = DllStructSetData($stAppName, 1, 'Fenetre_Simple')
Global $szClassName = DllStructSetData($stAppName, 2, 'WindowClass')
Global $hInst = GetModuleHandle("")

Global $DrawText = 'Hello AutoIt3 !'

WinMain()
DllCallbackFree($hWindowProc)
$stAppName = 0

;~Etape 4: Procdure de la fentre | window Procedure
Func WindowProc($hWnd, $uMsg, $wParam, $lParam)
	Local $hDC
	Local $Ps
	Local $Rct

	Switch $uMsg
		Case $WM_CREATE
			SoundPlay(@WindowsDir & "\media\tada.wav", 0)
			Return 0
		Case $WM_PAINT
			$Rct = DllStructCreate($RECT)
			$Ps = DllStructCreate($PAINTSTRUCT) 
			$hDC = BeginPaint($hWnd, $Ps)
			GetClientRect($hWnd, $Rct)
			DrawText($hDC, $DrawText, -1, $Rct, BitOR($DT_SINGLELINE, $DT_CENTER, $DT_VCENTER))
			EndPaint($hWnd, $Ps)
			$hDC = 0
			$Ps = 0
			$Rct = 0
			Return 0
		Case $WM_CLOSE
			DestroyWindow($hWnd)
			Return 0
		Case $WM_DESTROY
			PostQuitMessage(0)
			Return 0
		Case Else
			Return DefWindowProc($hWnd, $uMsg, $wParam, $lParam)
	EndSwitch
	
	Return 0
EndFunc   ;==>WindowProc

Func WinMain()

	Local $hWnd = WinGetHandle("")
	Local $iMsg = DllStructCreate($MSG)
	Local $WC = DllStructCreate($WNDCLASSEX)
	
	;~Etape 1: Class de fentre enregistrer | Registering the Window Class
	DllStructSetData($WC, 'cbSize', DllStructGetSize($WC))					
	DllStructSetData($WC, 'style', BitOR($CS_HREDRAW, $CS_VREDRAW))	
	DllStructSetData($WC, 'lpfnWndProc', DllCallbackGetPtr($hWindowProc))
	DllStructSetData($WC, 'cbClsExtra', 0)
	DllStructSetData($WC, 'cbWndExtra', 0)
	DllStructSetData($WC, 'hInstance', $hInst)
	DllStructSetData($WC, 'hIcon', LoadIcon($NULL, $IDI_ASTERISK))		 ;icone alt+tab
	DllStructSetData($WC, 'hCursor', LoadCursor($NULL, $IDC_ARROW))
	DllStructSetData($WC, 'hbrBackground', GetStockObject($WHITE_BRUSH))
	DllStructSetData($WC, 'lpszMenuName', $NULL)
	DllStructSetData($WC, 'lpszClassName', DllStructGetPtr($stAppName, 2))
	DllStructSetData($WC, 'hIconSm', LoadIcon($NULL, $IDI_WINLOGO))

	If Not RegisterClassEx($WC) Then
		MessageBox($NULL, "Window Registration Failed!", "Error!", BitOR($MB_ICONEXCLAMATION, $MB_OK))
		Return 0
	EndIf
	
	;~Etape 2: Cration de la fentre | Create window
	$hWnd = CreateWindowEx($WS_EX_OVERLAPPEDWINDOW, $szClassName, $szAppName, $WS_OVERLAPPEDWINDOW, _
			$CW_USEDEFAULT, $CW_USEDEFAULT, $CW_USEDEFAULT, $CW_USEDEFAULT, _
			$NULL, $NULL, $hInst, $NULL)

	If ($hWnd == $NULL) Then
		MessageBox($NULL, "Window Creation Failed!", "Error!", BitOR($MB_ICONEXCLAMATION, $MB_OK))
		Return 0
	EndIf
	
	ShowWindow($hWnd, 5)
	UpdateWindow($hWnd)
	
	;~Etape 3: Message loop | The Message Loop
	While GetMessage($iMsg, $NULL, 0, 0) > 0 And - 1
		TranslateMessage($iMsg)
		DispatchMessage($iMsg)
	WEnd
	
	$iMsg = 0
	$WC = 0
	
	Return DllStructGetData($iMsg, 'wParam')
	
EndFunc   ;==>WinMain
