Opt('OnExitFunc', 'CloseDllHandles')

Global $gdi32dll		=	DllOpen('gdi32.dll')
Global $user32dll		=	DllOpen('user32.dll')
Global $shell32dll		=	DllOpen('shell32.dll')
Global $kernel32dll 	=	DllOpen('kernel32.dll')

Func CloseDllHandles()
	DllClose($gdi32dll)
	DllClose($user32dll)
	DllClose($shell32dll)
	DllClose($kernel32dll)
EndFunc

;=====================================================================================================
; Structure
;=====================================================================================================
Global Const $MSG			=	'hwnd hwnd;uint message;uint wParam;long lParam;dword time;long;long'
Global Const $PAINTSTRUCT	=	'hwnd hDC;int  fErase;long rcPaint[4];int  fRestore;int  fIncUpdate;byte rgbReserved[32]'
Global Const $RECT			=	'long left;long top;long right;long bottom'
Global Const $WNDCLASSEX	=	'uint cbSize;uint style;ptr  lpfnWndProc;int  cbClsExtra;int  cbWndExtra;ptr  hInstance;' & _
								'ptr  hIcon;ptr  hCursor;ptr  hbrBackground;ptr  lpszMenuName;ptr  lpszClassName;ptr  hIconSm'
;=====================================================================================================
; Macro
;=====================================================================================================
Func MAKEINTRESOURCE($lID)
	Return "#" & String(Int($lID))
EndFunc
;=====================================================================================================
; Stock Object Constants
;=====================================================================================================
Global Const $WHITE_BRUSH = 0 ; White brush
;=====================================================================================================
; Message Box Constants
;=====================================================================================================
; Indicates the buttons displayed in the message box
Global Const $MB_OK = 0 ; One push button: OK
; Displays an icon in the message box
Global Const $MB_ICONEXCLAMATION = 48 ; Exclamation-point icon

; ===============================================================================================================================
; DrawText Constants
; ===============================================================================================================================
Global Const $DT_CENTER = 0x00000001
Global Const $DT_VCENTER = 0x00000004
Global Const $DT_SINGLELINE = 0x00000020
;=====================================================================================================
;Window Constant Message
;=====================================================================================================
Global Const $WM_CREATE = 0x0001
Global Const $WM_DESTROY = 0x0002
Global Const $WM_CLOSE = 0x0010
Global Const $WM_PAINT = 0x000F
;=====================================================================================================
; Window Styles
;=====================================================================================================
Global Const $WS_OVERLAPPEDWINDOW = 0x00CF0000
;=====================================================================================================
;Window Extended Style
;=====================================================================================================
Global Const $WS_EX_OVERLAPPEDWINDOW = 0x00000300
;=====================================================================================================
; Mouse Constants
;=====================================================================================================
; Indicates current mouse cursor
Global const $IDI_WINLOGO = 32517
Global const $IDI_ASTERISK = 32516
Global Const $IDI_APPLICATION = 32512
Global Const $IDC_ARROW = MAKEINTRESOURCE(32512)
;=====================================================================================================
;Variables +
;=====================================================================================================
Global Const $NULL = Ptr(0)

Global Const $CS_VREDRAW = 0x0001
Global Const $CS_HREDRAW = 0x0002
Global Const $CW_USEDEFAULT = 0x80000000
Global Const  $ES_MULTILINE = 0x0004 

Global Const $FORMAT_MESSAGE_FROM_SYSTEM = 0x1000


;=====================================================================================================
; Function 
;=====================================================================================================

Func GetModuleHandle($sModuleName)
	Local $tText, $aResult

	If $sModuleName <> "" Then
		$tText = DllStructCreate("char Text[4096]")
		DllStructSetData($tText, "Text", $sModuleName)
		$aResult = DllCall($Kernel32dll, "hwnd", "GetModuleHandle", "ptr", DllStructGetPtr($tText))
	Else
		$aResult = DllCall($Kernel32dll, "hwnd", "GetModuleHandle", "ptr", 0)
	EndIf
	Check("GetModuleHandle", ($aResult[0] = 0), 0, True)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_GetModuleHandle

;=====================================================================================================
; Partie 1 = Func WindowProc(...............)
;=====================================================================================================

Func BeginPaint($hWnd, byref $lpPaint)
	Local $aResult = DllCall($user32dll, 'hwnd', 'BeginPaint', 'hwnd', $hWnd, 'ptr', DllStructGetPtr($lpPaint))
	Return $aResult[0]
EndFunc

Func GetClientRect($hWnd, ByRef $tRect)
	local $aResult
	$aResult = DllCall($user32dll, "int", "GetClientRect", "hwnd", $hWnd, "ptr", DllStructGetPtr($tRect))
	Check("GetClientRect", ($aResult[0] = 0), 0, True)
	Return $tRect
EndFunc   ;==>_WinAPI_GetClientRect

Func DrawText($hDC, $sText, $ncount, ByRef $tRect, $iFlags)
	Local $aResult
	$aResult = DllCall($user32dll, "int", "DrawText", "ptr", $hDC, "str", $sText, "int", $ncount, "ptr", DllStructGetPtr($tRect), "uint", $iFlags)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_DrawText

Func EndPaint($hWnd, byref $lpPaint)
	Local $aResult = DllCall($user32dll, 'int', 'EndPaint', 'hwnd', $hWnd, 'ptr', DllStructGetPtr($lpPaint))
	Return $aResult[0]
EndFunc

Func DestroyWindow($hWnd)
	Local $aResult
	$aResult = DllCall($user32dll, "int", "DestroyWindow", "hwnd", $hWnd)
	Return $aResult[0] <> 0
EndFunc   ;==>_WinAPI_DestroyWindow

Func PostQuitMessage($nExitCode = 0)
	Local $aResult = DllCall($user32dll, 'none', 'PostQuitMessage', 'int', $nExitCode)
	Return $aResult[0]		
EndFunc

Func DefWindowProc($hWnd, $iMsg, $iwParam, $ilParam)
	Local $aResult
	$aResult = DllCall($user32dll, "int", "DefWindowProc", "hwnd", $hWnd, "int", $iMsg, "int", $iwParam, "int", $ilParam)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_DefWindowProc

;=====================================================================================================
; Partie 2 = Func WinMain()
;=====================================================================================================

Func LoadIcon($hInstance, $szIconName)
	If IsNumber($szIconName) Then $szIconName = MAKEINTRESOURCE($szIconName)
	Local $aResult = DllCall($user32dll, 'ptr', 'LoadIcon', 'ptr', $hInstance, 'str', $szIconName)
	Return $aResult[0]	
EndFunc

Func LoadCursor($hInstance, $szCursorName)
	If IsNumber($szCursorName) Then $szCursorName = MAKEINTRESOURCE($szCursorName)
	Local $aResult = DllCall($user32dll, 'ptr', 'LoadCursor', 'ptr', $hInstance, 'str', $szCursorName)
	Return $aResult[0]	
EndFunc

Func GetStockObject($iObject)
	Local $aResult
	$aResult = DllCall($GDI32dll, "hwnd", "GetStockObject", "int", $iObject)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_GetStockObject

Func RegisterClassEx(byref $lpwcx)
	Local $aResult = DllCall($user32dll, 'dword', 'RegisterClassEx', 'ptr', DllStructGetPtr($lpwcx))
	Return $aResult[0]
EndFunc

Func messagebox($hwnd,$lpText,$lpCaption,$Type)
	Local $aResult
	$aResult = DllCall( $user32dll, "int", "MessageBox", "hwnd", $hwnd, "str", $lpText, "str", $lpCaption, "int", $type)
	Return $aResult[0]
EndFunc

Func CreateWindowEx($iExStyle, $sClass, $sName, $iStyle, $iX, $iY, $iWidth, $iHeight, $hParent, $hMenu = 0, $hInstance = 0, $pParam = 0)
	Local $aResult
	If $hInstance = 0 Then $hInstance =GetModuleHandle("")
	$aResult = DllCall($user32dll, "hwnd", "CreateWindowEx", "int", $iExStyle, "str", $sClass, "str", $sName, "int", $iStyle, "int", $iX, _
			"int", $iY, "int", $iWidth, "int", $iHeight, "hwnd", $hParent, "hwnd", $hMenu, "hwnd", $hInstance, "ptr", $pParam)
	Check("CreateWindowEx", ($aResult[0] = 0), 0, True)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_CreateWindowEx

Func ShowWindow($hWnd, $iCmdShow = 5)
	Local $aResult = DllCall($user32dll, "int", "ShowWindow", "hwnd", $hWnd, "int", $iCmdShow)
	Return $aResult[0] <> 0
EndFunc   ;==>_WinAPI_ShowWindow

Func UpdateWindow($hWnd)
	Local $aResult = DllCall($user32dll, "int", "UpdateWindow", "hwnd", $hWnd)
	Return $aResult[0] <> 0
EndFunc   ;==>_WinAPI_UpdateWindow

Func GetMessage(ByRef $lpMsg, $hWnd, $wMsgFilterMin, $wMsgFilterMax)
	Local $aResult = DllCall($user32dll, 'int', 'GetMessage', 'ptr',  DllStructGetPtr($lpMsg), _
						'hwnd', $hWnd, 'uint', $wMsgFilterMin, 'uint', $wMsgFilterMax)
	Return $aResult[0]
EndFunc

Func TranslateMessage(byref $lpMsg)
	Local $aResult = DllCall($user32dll, 'int', 'TranslateMessage', 'ptr', DllStructGetPtr($lpMsg))
	Return $aResult[0]	
EndFunc

Func DispatchMessage(ByRef $lpMsg)	
	Local $aResult = DllCall($user32dll, 'long', 'DispatchMessage', 'ptr', DllStructGetPtr($lpMsg))
	Return $aResult
EndFunc

;=====================================================================================================
; Erreur checking :)
;=====================================================================================================

Func Check($sFunction, $fError, $vError, $fTranslate = False)
	If $fError Then
		If $fTranslate Then $vError = GetLastErrorMessage()
		ShowError($sFunction & ": " & $vError)
	EndIf
EndFunc   ;==>_WinAPI_Check

Func GetLastErrorMessage()
	Local $tText
	$tText = DllStructCreate("char Text[4096]")
	FormatMessage($FORMAT_MESSAGE_FROM_SYSTEM, 0, GetLastError(), 0, DllStructGetPtr($tText), 4096, 0)
	Return DllStructGetData($tText, "Text")
EndFunc   ;==>_WinAPI_GetLastErrorMessage

Func ShowError($sText, $fExit = True)
	_WinAPI_MsgBox(266256, "Error", $sText)
	If $fExit Then Exit
EndFunc   ;==>_WinAPI_ShowError

Func _WinAPI_MsgBox($iFlags, $sTitle, $sText)
	BlockInput(0)
	MsgBox($iFlags, $sTitle, $sText & "      ")
EndFunc   ;==>_WinAPI_MsgBox

Func FormatMessage($iFlags, $pSource, $iMessageID, $iLanguageID, $pBuffer, $iSize, $vArguments)
	Local $aResult
	$aResult = DllCall($Kernel32dll, "int", "FormatMessageA", "int", $iFlags, "hwnd", $pSource, "int", $iMessageID, "int", $iLanguageID, _
			"ptr", $pBuffer, "int", $iSize, "ptr", $vArguments)
	Return $aResult[0]
EndFunc   ;==>_WinAPI_FormatMessage

Func GetLastError()
	Local $aResult
	$aResult = DllCall($Kernel32dll, "int", "GetLastError")
	Return $aResult[0]
EndFunc   ;==>_WinAPI_GetLastError

